/*!
 * @module browser-dtector
 * @description A Javascript library to detect browser, version and platform
 * @version 1.0.1
 * @link https://github.com/sibiraj-s/browser-dtector.git
 * @licence MIT License, https://opensource.org/licenses/MIT
 */
(function(global,factory){typeof exports==="object"&&typeof module!=="undefined"?module.exports=factory():typeof define==="function"&&define.amd?define(factory):(global=global||self,global.BrowserDtector=factory())})(this,function(){"use strict";var KnownBrowsers={chrome:"Google Chrome",crios:"Google Chrome",edge:"Microsoft Edge",fennec:"Mozilla Firefox",jsdom:"JsDOM",mozilla:"Mozilla Firefox",msie:"Microsoft Internet Explorer",opera:"Opera",opios:"Opera",opr:"Opera",rv:"Microsoft Internet Explorer",safari:"Safari",samsungbrowser:"Samsung Browser"};var KnownPlatforms={android:"Android",androidTablet:"Android Tablet",cros:"Chrome OS",fennec:"Android Tablet",ipad:"IPad",iphone:"IPhone",jsdom:"JsDOM",linux:"Linux",mac:"Macintosh",tablet:"Android Tablet",win:"Windows","windows phone":"Windows Phone",xbox:"Microsoft Xbox"};var version="1.0.1";var toFixed=function(num,fixed){var re=new RegExp("^-?\\d+(?:.\\d{0,"+(fixed||-1)+"})?");return num.toString().match(re)[0]};var BrowserDtector=/** @class */function(){function BrowserDtector(userAgent){var _this=this;this.__VERSION__=version;this.parseUserAgent=function(userAgent){var browserMatches={};var uaFresh=userAgent||_this.userAgent;
// convert to lower case and treat tabs and multiple sapces as single space
var ua=uaFresh.toLowerCase().replace(/\s\s+/g," ");var browserMatch=/(edge)\/([\w.]+)/.exec(ua)||/(opr)[\/]([\w.]+)/.exec(ua)||/(jsdom)[\/]([\w.]+)/.exec(ua)||/(samsungbrowser)[\/]([\w.]+)/.exec(ua)||/(chrome)[\/]([\w.]+)/.exec(ua)||/(crios)[\/]([\w.]+)/.exec(ua)||/(opios)[\/]([\w.]+)/.exec(ua)||/(version)(applewebkit)[\/]([\w.]+).*(safari)[\/]([\w.]+)/.exec(ua)||/(webkit)[\/]([\w.]+).*(version)[\/]([\w.]+).*(safari)[\/]([\w.]+)/.exec(ua)||/(applewebkit)[\/]([\w.]+).*(safari)[\/]([\w.]+)/.exec(ua)||/(webkit)[\/]([\w.]+)/.exec(ua)||/(opera)(?:.*version|)[\/]([\w.]+)/.exec(ua)||/(msie) ([\w.]+)/.exec(ua)||/(fennec)[\/]([\w.]+)/.exec(ua)||ua.indexOf("trident")>=0&&/(rv)(?::| )([\w.]+)/.exec(ua)||ua.indexOf("compatible")<0&&/(mozilla)(?:.*? rv:([\w.]+)|)/.exec(ua)||[];var platformMatch=/(ipad)/.exec(ua)||/(ipod)/.exec(ua)||/(iphone)/.exec(ua)||/(jsdom)/.exec(ua)||/(windows phone)/.exec(ua)||/(xbox)/.exec(ua)||/(win)/.exec(ua)||/(tablet)/.exec(ua)||/(android)/.test(ua)&&/(mobile)/.test(ua)===false&&["androidTablet"]||/(android)/.exec(ua)||/(mac)/.exec(ua)||/(linux)/.exec(ua)||/(cros)/.exec(ua)||[];var browserInfo={name:browserMatch[5]||browserMatch[3]||browserMatch[1]||undefined,platform:platformMatch[0]||undefined,userAgent:uaFresh,version:browserMatch[4]||browserMatch[2]||undefined};if(!browserInfo.name){Object.keys(browserInfo).forEach(function(key){return browserInfo[key]="Unknown"});return browserInfo}if(browserInfo.name){browserMatches[browserInfo.name]=true;browserInfo.name=BrowserDtector.KnownBrowsers[browserInfo.name]||"Unknown"}if(browserInfo.platform){browserMatches[browserInfo.platform]=true;browserInfo.platform=BrowserDtector.KnownPlatforms[browserInfo.platform]||"Unknown"}if(browserInfo.version){browserInfo.shortVersion=toFixed(parseFloat(browserInfo.version),2)}browserInfo.isAndroid=!!(browserMatches.tablet||browserMatches.android||browserMatches.androidTablet);browserInfo.isTablet=!!(browserMatches.ipad||browserMatches.tablet||browserMatches.androidTablet);browserInfo.isMobile=!!(browserMatches.android||browserMatches.androidTablet||browserMatches.tablet||browserMatches.ipad||browserMatches.ipod||browserMatches.iphone||browserMatches["windows phone"]);browserInfo.isDesktop=!!(browserMatches.cros||browserMatches.mac||browserMatches.linux||browserMatches.win);browserInfo.isWebkit=!!(browserMatches.chrome||browserMatches.crios||browserMatches.opr||browserMatches.safari);browserInfo.isIE=!!(browserMatches.msie||browserMatches.rv);return browserInfo};this.getBrowserInfo=function(){var browserInfo=_this.parseUserAgent();delete browserInfo.isAndroid;delete browserInfo.isMobile;delete browserInfo.isTablet;delete browserInfo.isWebkit;delete browserInfo.isDesktop;delete browserInfo.isIE;return browserInfo};this.getBrowserName=function(){return _this.parseUserAgent().name};this.getBrowserVersion=function(){return _this.parseUserAgent().version};this.getBrowserShortVersion=function(){return _this.parseUserAgent().shortVersion||"Unknown"};this.getPlatformName=function(){return _this.parseUserAgent().platform};this.isAndroid=function(){return _this.parseUserAgent().isAndroid};this.isTablet=function(){return _this.parseUserAgent().isTablet};this.isMobile=function(){return _this.parseUserAgent().isMobile};this.isWebkit=function(){return _this.parseUserAgent().isWebkit};this.isDesktop=function(){return _this.parseUserAgent().isDesktop};this.isIE=function(){return _this.parseUserAgent().isIE};this.userAgent=userAgent||window.navigator.userAgent}BrowserDtector.KnownBrowsers=KnownBrowsers;BrowserDtector.KnownPlatforms=KnownPlatforms;return BrowserDtector}();return BrowserDtector});
//# sourceMappingURL=browser-dtector.js.map